diff --git a/doc/src/sgml/extend.sgml b/doc/src/sgml/extend.sgml
index 63c5ec6d1eb..d4ae0553539 100644
--- a/doc/src/sgml/extend.sgml
+++ b/doc/src/sgml/extend.sgml
@@ -46,7 +46,7 @@
    </itemizedlist>
   </para>
 
-  <sect1 id="extend-how">
+  <sect1 id="extend-how" xreflabel="How Extensibility Works">
    <title>How Extensibility Works</title>
 
    <para>
@@ -85,7 +85,7 @@
    </para>
   </sect1>
 
-  <sect1 id="extend-type-system">
+  <sect1 id="extend-type-system" xreflabel="The PostgreSQL Type System">
    <title>The <productname>PostgreSQL</productname> Type System</title>
 
    <indexterm zone="extend-type-system">
@@ -120,7 +120,7 @@
     types, container types, domains, and pseudo-types.
    </para>
 
-   <sect2 id="extend-type-system-base">
+   <sect2 id="extend-type-system-base" xreflabel="Base Types">
     <title>Base Types</title>
 
     <para>
@@ -143,7 +143,7 @@
     </para>
    </sect2>
 
-   <sect2 id="extend-type-system-container">
+   <sect2 id="extend-type-system-container" xreflabel="Container Types">
     <title>Container Types</title>
 
     <para>
@@ -180,7 +180,7 @@
     </para>
    </sect2>
 
-   <sect2 id="extend-type-system-domains">
+   <sect2 id="extend-type-system-domains" xreflabel="Domains">
     <title>Domains</title>
 
     <para>
@@ -193,7 +193,7 @@
     </para>
    </sect2>
 
-   <sect2 id="extend-type-system-pseudo">
+   <sect2 id="extend-type-system-pseudo" xreflabel="Pseudo-Types">
     <title>Pseudo-Types</title>
 
     <para>
@@ -207,7 +207,7 @@
     </para>
    </sect2>
 
-   <sect2 id="extend-types-polymorphic">
+   <sect2 id="extend-types-polymorphic" xreflabel="Polymorphic Types">
     <title>Polymorphic Types</title>
 
    <indexterm zone="extend-types-polymorphic">
@@ -515,7 +515,7 @@ RETURNS anycompatible AS ...
   &xindex;
 
 
-  <sect1 id="extend-extensions">
+  <sect1 id="extend-extensions" xreflabel="Packaging Related Objects into an Extension">
    <title>Packaging Related Objects into an Extension</title>
 
    <indexterm zone="extend-extensions">
@@ -628,7 +628,7 @@ RETURNS anycompatible AS ...
     dropping the whole extension.
    </para>
 
-   <sect2 id="extend-extensions-files">
+   <sect2 id="extend-extensions-files" xreflabel="Extension Files">
     <title>Extension Files</title>
 
    <indexterm>
@@ -887,7 +887,7 @@ RETURNS anycompatible AS ...
 
    </sect2>
 
-   <sect2 id="extend-extensions-relocation">
+   <sect2 id="extend-extensions-relocation" xreflabel="Extension Relocatability">
     <title>Extension Relocatability</title>
 
     <para>
@@ -1015,7 +1015,7 @@ SET LOCAL search_path TO @extschema@, pg_temp;
     </para>
    </sect2>
 
-   <sect2 id="extend-extensions-config-tables">
+   <sect2 id="extend-extensions-config-tables" xreflabel="Extension Configuration Tables">
     <title>Extension Configuration Tables</title>
 
     <para>
@@ -1107,7 +1107,7 @@ SELECT pg_catalog.pg_extension_config_dump('my_config', 'WHERE NOT standard_entr
     </para>
    </sect2>
 
-   <sect2 id="extend-extensions-updates">
+   <sect2 id="extend-extensions-updates" xreflabel="Extension Updates">
     <title>Extension Updates</title>
 
     <para>
@@ -1188,7 +1188,7 @@ SELECT * FROM pg_extension_update_paths('<replaceable>extension_name</replaceabl
     </para>
    </sect2>
 
-   <sect2 id="extend-extensions-update-scripts">
+   <sect2 id="extend-extensions-update-scripts" xreflabel="Installing Extensions Using Update Scripts">
     <title>Installing Extensions Using Update Scripts</title>
 
     <para>
@@ -1229,7 +1229,7 @@ SELECT * FROM pg_extension_update_paths('<replaceable>extension_name</replaceabl
     </para>
    </sect2>
 
-   <sect2 id="extend-extensions-security">
+   <sect2 id="extend-extensions-security" xreflabel="Security Considerations for Extensions">
     <title>Security Considerations for Extensions</title>
 
     <para>
@@ -1264,7 +1264,7 @@ SELECT * FROM pg_extension_update_paths('<replaceable>extension_name</replaceabl
      <xref linkend="extend-extensions-security-scripts"/>.
     </para>
 
-    <sect3 id="extend-extensions-security-funcs">
+    <sect3 id="extend-extensions-security-funcs" xreflabel="Security Considerations for Extension Functions">
      <title>Security Considerations for Extension Functions</title>
 
      <para>
@@ -1316,7 +1316,7 @@ SELECT * FROM pg_extension_update_paths('<replaceable>extension_name</replaceabl
      </para>
     </sect3>
 
-    <sect3 id="extend-extensions-security-scripts">
+    <sect3 id="extend-extensions-security-scripts" xreflabel="Security Considerations for Extension Scripts">
      <title>Security Considerations for Extension Scripts</title>
 
      <para>
@@ -1362,7 +1362,7 @@ SELECT * FROM pg_extension_update_paths('<replaceable>extension_name</replaceabl
     </sect3>
    </sect2>
 
-   <sect2 id="extend-extensions-example">
+   <sect2 id="extend-extensions-example" xreflabel="Extension Example">
     <title>Extension Example</title>
 
     <para>
@@ -1439,7 +1439,7 @@ include $(PGXS)
    </sect2>
   </sect1>
 
-  <sect1 id="extend-pgxs">
+  <sect1 id="extend-pgxs" xreflabel="Extension Building Infrastructure">
    <title>Extension Building Infrastructure</title>
 
    <indexterm zone="extend-pgxs">
diff --git a/doc/src/sgml/external-projects.sgml b/doc/src/sgml/external-projects.sgml
index 50872dfd88e..850943ba7b6 100644
--- a/doc/src/sgml/external-projects.sgml
+++ b/doc/src/sgml/external-projects.sgml
@@ -10,7 +10,7 @@
    efficiently developed separately from the core project.
   </para>
 
- <sect1 id="external-interfaces">
+ <sect1 id="external-interfaces" xreflabel="Client Interfaces">
   <title>Client Interfaces</title>
 
   <indexterm>
@@ -53,7 +53,7 @@
   </para>
  </sect1>
 
- <sect1 id="external-admin-tools">
+ <sect1 id="external-admin-tools" xreflabel="Administration Tools">
  <title>Administration Tools</title>
 
   <indexterm>
@@ -69,7 +69,7 @@
   </para>
  </sect1>
 
- <sect1 id="external-pl">
+ <sect1 id="external-pl" xreflabel="Procedural Languages">
   <title>Procedural Languages</title>
 
   <indexterm>
@@ -102,7 +102,7 @@
   </para>
  </sect1>
 
- <sect1 id="external-extensions">
+ <sect1 id="external-extensions" xreflabel="Extensions">
  <title>Extensions</title>
 
   <indexterm>
diff --git a/doc/src/sgml/fdwhandler.sgml b/doc/src/sgml/fdwhandler.sgml
index c6d66414b8e..faccdbd3faa 100644
--- a/doc/src/sgml/fdwhandler.sgml
+++ b/doc/src/sgml/fdwhandler.sgml
@@ -35,7 +35,7 @@
     </para>
    </note>
 
-   <sect1 id="fdw-functions">
+   <sect1 id="fdw-functions" xreflabel="Foreign Data Wrapper Functions">
     <title>Foreign Data Wrapper Functions</title>
 
     <para>
@@ -83,7 +83,7 @@
 
    </sect1>
 
-   <sect1 id="fdw-callbacks">
+   <sect1 id="fdw-callbacks" xreflabel="Foreign Data Wrapper Callback Routines">
     <title>Foreign Data Wrapper Callback Routines</title>
 
     <para>
@@ -98,7 +98,7 @@
      details.
     </para>
 
-   <sect2 id="fdw-callbacks-scan">
+   <sect2 id="fdw-callbacks-scan" xreflabel="FDW Routines for Scanning Foreign Tables">
     <title>FDW Routines for Scanning Foreign Tables</title>
 
     <para>
@@ -297,7 +297,7 @@ EndForeignScan(ForeignScanState *node);
 
    </sect2>
 
-   <sect2 id="fdw-callbacks-join-scan">
+   <sect2 id="fdw-callbacks-join-scan" xreflabel="FDW Routines for Scanning Foreign Joins">
     <title>FDW Routines for Scanning Foreign Joins</title>
 
     <para>
@@ -381,7 +381,7 @@ GetForeignJoinPaths(PlannerInfo *root,
     </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-upper-planning">
+   <sect2 id="fdw-callbacks-upper-planning" xreflabel="FDW Routines for Planning Post-Scan/Join Processing">
     <title>FDW Routines for Planning Post-Scan/Join Processing</title>
 
     <para>
@@ -437,7 +437,7 @@ GetForeignUpperPaths(PlannerInfo *root,
     </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-update">
+   <sect2 id="fdw-callbacks-update" xreflabel="FDW Routines for Updating Foreign Tables">
     <title>FDW Routines for Updating Foreign Tables</title>
 
     <para>
@@ -1092,7 +1092,7 @@ EndDirectModify(ForeignScanState *node);
 
    </sect2>
 
-   <sect2 id="fdw-callbacks-truncate">
+   <sect2 id="fdw-callbacks-truncate" xreflabel="FDW Routines for TRUNCATE">
     <title>FDW Routines for <command>TRUNCATE</command></title>
 
     <para>
@@ -1147,7 +1147,7 @@ ExecForeignTruncate(List *rels,
     </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-row-locking">
+   <sect2 id="fdw-callbacks-row-locking" xreflabel="FDW Routines for Row Locking">
     <title>FDW Routines for Row Locking</title>
 
     <para>
@@ -1288,7 +1288,7 @@ RecheckForeignScan(ForeignScanState *node,
     </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-explain">
+   <sect2 id="fdw-callbacks-explain" xreflabel="FDW Routines for EXPLAIN">
     <title>FDW Routines for <command>EXPLAIN</command></title>
 
     <para>
@@ -1364,7 +1364,7 @@ ExplainDirectModify(ForeignScanState *node,
 
    </sect2>
 
-   <sect2 id="fdw-callbacks-analyze">
+   <sect2 id="fdw-callbacks-analyze" xreflabel="FDW Routines for ANALYZE">
     <title>FDW Routines for <command>ANALYZE</command></title>
 
     <para>
@@ -1411,7 +1411,7 @@ AcquireSampleRowsFunc(Relation relation,
 
    </sect2>
 
-   <sect2 id="fdw-callbacks-import">
+   <sect2 id="fdw-callbacks-import" xreflabel="FDW Routines for IMPORT FOREIGN SCHEMA">
     <title>FDW Routines for <command>IMPORT FOREIGN SCHEMA</command></title>
 
     <para>
@@ -1471,7 +1471,7 @@ ImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid);
 
    </sect2>
 
-   <sect2 id="fdw-callbacks-parallel">
+   <sect2 id="fdw-callbacks-parallel" xreflabel="FDW Routines for Parallel Execution">
     <title>FDW Routines for Parallel Execution</title>
     <para>
      A <structname>ForeignScan</structname> node can, optionally, support parallel
@@ -1574,7 +1574,7 @@ ShutdownForeignScan(ForeignScanState *node);
    </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-async">
+   <sect2 id="fdw-callbacks-async" xreflabel="FDW Routines for Asynchronous Execution">
     <title>FDW Routines for Asynchronous Execution</title>
     <para>
      A <structname>ForeignScan</structname> node can, optionally, support
@@ -1664,7 +1664,7 @@ ForeignAsyncNotify(AsyncRequest *areq);
     </para>
    </sect2>
 
-   <sect2 id="fdw-callbacks-reparameterize-paths">
+   <sect2 id="fdw-callbacks-reparameterize-paths" xreflabel="FDW Routines for Reparameterization of Paths">
     <title>FDW Routines for Reparameterization of Paths</title>
 
     <para>
@@ -1686,7 +1686,7 @@ ReparameterizeForeignPathByChild(PlannerInfo *root, List *fdw_private,
 
    </sect1>
 
-   <sect1 id="fdw-helpers">
+   <sect1 id="fdw-helpers" xreflabel="Foreign Data Wrapper Helper Functions">
     <title>Foreign Data Wrapper Helper Functions</title>
 
     <para>
@@ -1825,7 +1825,7 @@ GetForeignServerByName(const char *name, bool missing_ok);
 
    </sect1>
 
-   <sect1 id="fdw-planning">
+   <sect1 id="fdw-planning" xreflabel="Foreign Data Wrapper Query Planning">
     <title>Foreign Data Wrapper Query Planning</title>
 
     <para>
@@ -2051,7 +2051,7 @@ GetForeignServerByName(const char *name, bool missing_ok);
 
    </sect1>
 
-   <sect1 id="fdw-row-locking">
+   <sect1 id="fdw-row-locking" xreflabel="Row Locking in Foreign Data Wrappers">
     <title>Row Locking in Foreign Data Wrappers</title>
 
     <para>
diff --git a/doc/src/sgml/features.sgml b/doc/src/sgml/features.sgml
index 966fd398827..93ab8f15f91 100644
--- a/doc/src/sgml/features.sgml
+++ b/doc/src/sgml/features.sgml
@@ -106,7 +106,7 @@
   </para>
  </note>
 
-  <sect1 id="features-sql-standard">
+  <sect1 id="features-sql-standard" xreflabel="Supported Features">
    <title>Supported Features</title>
 
    <para>
@@ -132,7 +132,7 @@
    </para>
   </sect1>
 
-  <sect1 id="unsupported-features-sql-standard">
+  <sect1 id="unsupported-features-sql-standard" xreflabel="Unsupported Features">
    <title>Unsupported Features</title>
 
    <para>
@@ -163,7 +163,7 @@
    </para>
   </sect1>
 
-  <sect1 id="xml-limits-conformance">
+  <sect1 id="xml-limits-conformance" xreflabel="XML Limits and Conformance to SQL/XML">
    <title>XML Limits and Conformance to SQL/XML</title>
 
    <indexterm>
@@ -398,7 +398,7 @@
      </para>
     </sect3>
 
-    <sect3 id="functions-xml-limits-casts">
+    <sect3 id="functions-xml-limits-casts" xreflabel="Mappings between SQL and XML Data Types and Values">
      <title>Mappings between SQL and XML Data Types and Values</title>
 
      <para>
@@ -428,7 +428,7 @@
     </sect3>
    </sect2>
 
-   <sect2 id="functions-xml-limits-postgresql">
+   <sect2 id="functions-xml-limits-postgresql" xreflabel="Incidental Limits of the Implementation">
     <title>Incidental Limits of the Implementation</title>
 
     <para>
@@ -437,7 +437,7 @@
      implementation in <productname>PostgreSQL</productname>.
     </para>
 
-    <sect3 id="functions-xml-limits-postgresql-by-value-only">
+    <sect3 id="functions-xml-limits-postgresql-by-value-only" xreflabel="Only BY VALUE Passing Mechanism Is Supported">
      <title>Only <literal>BY VALUE</literal> Passing Mechanism Is Supported</title>
 
      <para>
@@ -473,7 +473,7 @@ SELECT XMLQUERY('$a is $b' PASSING BY VALUE <replaceable>x</replaceable> AS a, <
      </para>
     </sect3>
 
-    <sect3 id="functions-xml-limits-postgresql-named-parameters">
+    <sect3 id="functions-xml-limits-postgresql-named-parameters" xreflabel="Cannot Pass Named Parameters to Queries">
      <title>Cannot Pass Named Parameters to Queries</title>
 
      <para>
@@ -483,7 +483,7 @@ SELECT XMLQUERY('$a is $b' PASSING BY VALUE <replaceable>x</replaceable> AS a, <
      </para>
     </sect3>
 
-    <sect3 id="functions-xml-limits-postgresql-no-xml-sequence">
+    <sect3 id="functions-xml-limits-postgresql-no-xml-sequence" xreflabel="No XML(SEQUENCE) Type">
      <title>No <type>XML(SEQUENCE)</type> Type</title>
 
      <para>
diff --git a/doc/src/sgml/fuzzystrmatch.sgml b/doc/src/sgml/fuzzystrmatch.sgml
index bcadc440e39..f8053a8fa95 100644
--- a/doc/src/sgml/fuzzystrmatch.sgml
+++ b/doc/src/sgml/fuzzystrmatch.sgml
@@ -28,7 +28,7 @@
   on the current database.
  </para>
 
- <sect2 id="fuzzystrmatch-soundex">
+ <sect2 id="fuzzystrmatch-soundex" xreflabel="Soundex">
   <title>Soundex</title>
 
   <para>
@@ -90,7 +90,7 @@ SELECT * FROM s WHERE difference(s.nm, 'john') &gt; 2;
 </programlisting>
  </sect2>
 
- <sect2 id="fuzzystrmatch-daitch-mokotoff">
+ <sect2 id="fuzzystrmatch-daitch-mokotoff" xreflabel="Daitch-Mokotoff Soundex">
   <title>Daitch-Mokotoff Soundex</title>
 
   <para>
@@ -243,7 +243,7 @@ SELECT * FROM s WHERE soundex_tsvector(nm) @@ soundex_tsquery('Jameson John');
   </para>
  </sect2>
 
- <sect2 id="fuzzystrmatch-levenshtein">
+ <sect2 id="fuzzystrmatch-levenshtein" xreflabel="Levenshtein">
   <title>Levenshtein</title>
 
   <para>
@@ -314,7 +314,7 @@ test=# SELECT levenshtein_less_equal('extensive', 'exhaustive', 4);
 </screen>
  </sect2>
 
- <sect2 id="fuzzystrmatch-metaphone">
+ <sect2 id="fuzzystrmatch-metaphone" xreflabel="Metaphone">
   <title>Metaphone</title>
 
   <para>
@@ -355,7 +355,7 @@ test=# SELECT metaphone('GUMBO', 4);
 </screen>
  </sect2>
 
- <sect2 id="fuzzystrmatch-double-metaphone">
+ <sect2 id="fuzzystrmatch-double-metaphone" xreflabel="Double Metaphone">
   <title>Double Metaphone</title>
 
   <para>
diff --git a/doc/src/sgml/generic-wal.sgml b/doc/src/sgml/generic-wal.sgml
index 41f97ad7dc8..0bcaf48604c 100644
--- a/doc/src/sgml/generic-wal.sgml
+++ b/doc/src/sgml/generic-wal.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/generic-wal.sgml -->
 
-<sect1 id="generic-wal">
+<sect1 id="generic-wal" xreflabel="Generic WAL Records">
  <title>Generic WAL Records</title>
 
   <para>
diff --git a/doc/src/sgml/geqo.sgml b/doc/src/sgml/geqo.sgml
index 82bf3b690d8..da6cb62ee36 100644
--- a/doc/src/sgml/geqo.sgml
+++ b/doc/src/sgml/geqo.sgml
@@ -13,7 +13,7 @@
    </note>
   </para>
 
-  <sect1 id="geqo-intro">
+  <sect1 id="geqo-intro" xreflabel="Query Handling as a Complex Optimization Problem">
    <title>Query Handling as a Complex Optimization Problem</title>
 
    <para>
@@ -59,7 +59,7 @@
    </para>
   </sect1>
 
-  <sect1 id="geqo-intro2">
+  <sect1 id="geqo-intro2" xreflabel="Genetic Algorithms">
    <title>Genetic Algorithms</title>
 
    <para>
@@ -106,7 +106,7 @@
 
   </sect1>
 
-  <sect1 id="geqo-pg-intro">
+  <sect1 id="geqo-pg-intro" xreflabel="Genetic Query Optimization (GEQO) in PostgreSQL">
    <title>Genetic Query Optimization (<acronym>GEQO</acronym>) in PostgreSQL</title>
 
    <para>
@@ -173,7 +173,7 @@
     non-exhaustive search.
    </para>
 
-  <sect2 id="geqo-pg-intro-gen-possible-plans">
+  <sect2 id="geqo-pg-intro-gen-possible-plans" xreflabel="Generating Possible Plans with GEQO">
    <title>Generating Possible Plans with <acronym>GEQO</acronym></title>
 
    <para>
@@ -213,7 +213,7 @@
 
   </sect2>
 
-  <sect2 id="geqo-future">
+  <sect2 id="geqo-future" xreflabel="Future Implementation Tasks for PostgreSQL GEQO">
    <title>Future Implementation Tasks for
     <productname>PostgreSQL</productname> <acronym>GEQO</acronym></title>
 
@@ -261,7 +261,7 @@
    </sect2>
   </sect1>
 
- <sect1 id="geqo-biblio">
+ <sect1 id="geqo-biblio" xreflabel="Further Reading">
   <title>Further Reading</title>
 
   <para>
diff --git a/doc/src/sgml/gin.sgml b/doc/src/sgml/gin.sgml
index 82410b1fbdf..baac344075f 100644
--- a/doc/src/sgml/gin.sgml
+++ b/doc/src/sgml/gin.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/gin.sgml -->
 
-<sect1 id="gin">
+<sect1 id="gin" xreflabel="GIN Indexes">
 <title>GIN Indexes</title>
 
    <indexterm>
@@ -8,7 +8,7 @@
     <secondary>GIN</secondary>
    </indexterm>
 
-<sect2 id="gin-intro">
+<sect2 id="gin-intro" xreflabel="Introduction">
  <title>Introduction</title>
 
  <para>
@@ -62,7 +62,7 @@
  </para>
 </sect2>
 
-<sect2 id="gin-builtin-opclasses">
+<sect2 id="gin-builtin-opclasses" xreflabel="Built-in Operator Classes">
  <title>Built-in Operator Classes</title>
 
  <para>
@@ -142,7 +142,7 @@
 
 </sect2>
 
-<sect2 id="gin-extensibility">
+<sect2 id="gin-extensibility" xreflabel="Extensibility">
  <title>Extensibility</title>
 
  <para>
@@ -464,7 +464,7 @@
 
 </sect2>
 
-<sect2 id="gin-implementation">
+<sect2 id="gin-implementation" xreflabel="Implementation">
  <title>Implementation</title>
 
  <para>
@@ -501,7 +501,7 @@
   </mediaobject>
  </figure>
 
- <sect3 id="gin-fast-update">
+ <sect3 id="gin-fast-update" xreflabel="GIN Fast Update Technique">
   <title>GIN Fast Update Technique</title>
 
   <para>
@@ -541,7 +541,7 @@
   </para>
  </sect3>
 
- <sect3 id="gin-partial-match">
+ <sect3 id="gin-partial-match" xreflabel="Partial Match Algorithm">
   <title>Partial Match Algorithm</title>
 
   <para>
@@ -562,7 +562,7 @@
 
 </sect2>
 
-<sect2 id="gin-tips">
+<sect2 id="gin-tips" xreflabel="GIN Tips and Tricks">
 <title>GIN Tips and Tricks</title>
 
  <variablelist>
@@ -659,7 +659,7 @@
 
 </sect2>
 
-<sect2 id="gin-limit">
+<sect2 id="gin-limit" xreflabel="Limitations">
  <title>Limitations</title>
 
  <para>
@@ -673,7 +673,7 @@
  </para>
 </sect2>
 
-<sect2 id="gin-examples">
+<sect2 id="gin-examples" xreflabel="Examples">
  <title>Examples</title>
 
  <para>
diff --git a/doc/src/sgml/gist.sgml b/doc/src/sgml/gist.sgml
index 1871f742721..d6d2fa85ea2 100644
--- a/doc/src/sgml/gist.sgml
+++ b/doc/src/sgml/gist.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/gist.sgml -->
 
-<sect1 id="gist">
+<sect1 id="gist" xreflabel="GiST Indexes">
 <title>GiST Indexes</title>
 
    <indexterm>
@@ -8,7 +8,7 @@
     <secondary>GiST</secondary>
    </indexterm>
 
-<sect2 id="gist-intro">
+<sect2 id="gist-intro" xreflabel="Introduction">
  <title>Introduction</title>
 
  <para>
@@ -40,7 +40,7 @@
 
 </sect2>
 
-<sect2 id="gist-builtin-opclasses">
+<sect2 id="gist-builtin-opclasses" xreflabel="Built-in Operator Classes">
  <title>Built-in Operator Classes</title>
 
  <para>
@@ -218,7 +218,7 @@ CREATE INDEX ON my_table USING GIST (my_inet_column inet_ops);
 
 </sect2>
 
-<sect2 id="gist-extensibility">
+<sect2 id="gist-extensibility" xreflabel="Extensibility">
  <title>Extensibility</title>
 
  <para>
@@ -1270,10 +1270,10 @@ my_translate_cmptype(PG_FUNCTION_ARGS)
 
 </sect2>
 
-<sect2 id="gist-implementation">
+<sect2 id="gist-implementation" xreflabel="Implementation">
  <title>Implementation</title>
 
- <sect3 id="gist-buffering-build">
+ <sect3 id="gist-buffering-build" xreflabel="GiST Index Build Methods">
   <title>GiST Index Build Methods</title>
 
   <para>
@@ -1325,7 +1325,7 @@ my_translate_cmptype(PG_FUNCTION_ARGS)
  </sect3>
 </sect2>
 
-<sect2 id="gist-examples">
+<sect2 id="gist-examples" xreflabel="Examples">
  <title>Examples</title>
 
  <para>
diff --git a/doc/src/sgml/hash.sgml b/doc/src/sgml/hash.sgml
index 34f3b2cb0c1..15690b25513 100644
--- a/doc/src/sgml/hash.sgml
+++ b/doc/src/sgml/hash.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/hash.sgml -->
 
-<sect1 id="hash-index">
+<sect1 id="hash-index" xreflabel="Hash Indexes">
 <title>Hash Indexes</title>
 
    <indexterm>
@@ -8,7 +8,7 @@
     <secondary>Hash</secondary>
    </indexterm>
 
-<sect2 id="hash-intro">
+<sect2 id="hash-intro" xreflabel="Overview">
  <title>Overview</title>
 
  <para>
@@ -110,7 +110,7 @@
 
 </sect2>
 
-<sect2 id="hash-implementation">
+<sect2 id="hash-implementation" xreflabel="Implementation">
  <title>Implementation</title>
 
  <para>
diff --git a/doc/src/sgml/high-availability.sgml b/doc/src/sgml/high-availability.sgml
index 33ca3f0286c..d2f51a8a477 100644
--- a/doc/src/sgml/high-availability.sgml
+++ b/doc/src/sgml/high-availability.sgml
@@ -79,7 +79,7 @@
   and load balancing solutions.
  </para>
 
- <sect1 id="different-replication-solutions">
+ <sect1 id="different-replication-solutions" xreflabel="Comparison of Different Solutions">
  <title>Comparison of Different Solutions</title>
 
  <variablelist>
@@ -489,7 +489,7 @@ protocol to make nodes agree on a serializable transactional order.
  </sect1>
 
 
- <sect1 id="warm-standby">
+ <sect1 id="warm-standby" xreflabel="Log-Shipping Standby Servers">
  <title>Log-Shipping Standby Servers</title>
 
 
@@ -576,7 +576,7 @@ protocol to make nodes agree on a serializable transactional order.
    <primary>STONITH</primary>
   </indexterm>
 
-  <sect2 id="standby-planning">
+  <sect2 id="standby-planning" xreflabel="Planning">
    <title>Planning</title>
 
    <para>
@@ -660,7 +660,7 @@ protocol to make nodes agree on a serializable transactional order.
    </para>
   </sect2>
 
-  <sect2 id="preparing-primary-for-standby">
+  <sect2 id="preparing-primary-for-standby" xreflabel="Preparing the Primary for Standby Servers">
    <title>Preparing the Primary for Standby Servers</title>
 
    <para>
@@ -690,7 +690,7 @@ protocol to make nodes agree on a serializable transactional order.
    </para>
   </sect2>
 
-  <sect2 id="standby-server-setup">
+  <sect2 id="standby-server-setup" xreflabel="Setting Up a Standby Server">
    <title>Setting Up a Standby Server</title>
 
    <para>
@@ -758,7 +758,7 @@ archive_cleanup_command = 'pg_archivecleanup /path/to/archive "%r"'
 
   </sect2>
 
-  <sect2 id="streaming-replication">
+  <sect2 id="streaming-replication" xreflabel="Streaming Replication">
    <title>Streaming Replication</title>
 
    <indexterm zone="high-availability">
@@ -836,7 +836,7 @@ archive_cleanup_command = 'pg_archivecleanup /path/to/archive "%r"'
     a corresponding <literal>walsender</literal> process in the primary.
    </para>
 
-   <sect3 id="streaming-replication-authentication">
+   <sect3 id="streaming-replication-authentication" xreflabel="Authentication">
     <title>Authentication</title>
     <para>
      It is very important that the access privileges for replication be set up
@@ -888,7 +888,7 @@ primary_conninfo = 'host=192.168.1.50 port=5432 user=foo password=foopass'
     </para>
    </sect3>
 
-   <sect3 id="streaming-replication-monitoring">
+   <sect3 id="streaming-replication-monitoring" xreflabel="Monitoring">
     <title>Monitoring</title>
     <para>
      An important health indicator of streaming replication is the amount
@@ -925,7 +925,7 @@ primary_conninfo = 'host=192.168.1.50 port=5432 user=foo password=foopass'
    </sect3>
   </sect2>
 
-  <sect2 id="streaming-replication-slots">
+  <sect2 id="streaming-replication-slots" xreflabel="Replication Slots">
    <title>Replication Slots</title>
    <indexterm>
     <primary>replication slot</primary>
@@ -966,7 +966,7 @@ primary_conninfo = 'host=192.168.1.50 port=5432 user=foo password=foopass'
     </para>
    </caution>
 
-   <sect3 id="streaming-replication-slots-manipulation">
+   <sect3 id="streaming-replication-slots-manipulation" xreflabel="Querying and Manipulating Replication Slots">
     <title>Querying and Manipulating Replication Slots</title>
     <para>
      Each replication slot has a name, which can contain lower-case letters,
@@ -983,7 +983,7 @@ primary_conninfo = 'host=192.168.1.50 port=5432 user=foo password=foopass'
      functions (see <xref linkend="functions-replication"/>).
     </para>
    </sect3>
-   <sect3 id="streaming-replication-slots-config">
+   <sect3 id="streaming-replication-slots-config" xreflabel="Configuration Example">
     <title>Configuration Example</title>
     <para>
      You can create a physical replication slot on the primary like this:
@@ -1009,7 +1009,7 @@ primary_slot_name = 'node_a_slot'
    </sect3>
   </sect2>
 
-  <sect2 id="cascading-replication">
+  <sect2 id="cascading-replication" xreflabel="Cascading Replication">
    <title>Cascading Replication</title>
 
    <indexterm zone="high-availability">
@@ -1066,7 +1066,7 @@ primary_slot_name = 'node_a_slot'
    </para>
   </sect2>
 
-  <sect2 id="synchronous-replication">
+  <sect2 id="synchronous-replication" xreflabel="Synchronous Replication">
    <title>Synchronous Replication</title>
 
    <indexterm zone="high-availability">
@@ -1127,7 +1127,7 @@ primary_slot_name = 'node_a_slot'
     support.
    </para>
 
-   <sect3 id="synchronous-replication-config">
+   <sect3 id="synchronous-replication-config" xreflabel="Basic Configuration">
     <title>Basic Configuration</title>
 
    <para>
@@ -1198,7 +1198,7 @@ primary_slot_name = 'node_a_slot'
 
    </sect3>
 
-   <sect3 id="synchronous-replication-multiple-standbys">
+   <sect3 id="synchronous-replication-multiple-standbys" xreflabel="Multiple Synchronous Standbys">
     <title>Multiple Synchronous Standbys</title>
 
    <para>
@@ -1260,7 +1260,7 @@ synchronous_standby_names = 'ANY 2 (s1, s2, s3)'
    </para>
    </sect3>
 
-   <sect3 id="synchronous-replication-performance">
+   <sect3 id="synchronous-replication-performance" xreflabel="Planning for Performance">
     <title>Planning for Performance</title>
 
    <para>
@@ -1301,7 +1301,7 @@ synchronous_standby_names = 'ANY 2 (s1, s2, s3)'
 
    </sect3>
 
-   <sect3 id="synchronous-replication-ha">
+   <sect3 id="synchronous-replication-ha" xreflabel="Planning for High Availability">
     <title>Planning for High Availability</title>
 
    <para>
@@ -1384,7 +1384,7 @@ synchronous_standby_names = 'ANY 2 (s1, s2, s3)'
    </sect3>
   </sect2>
 
-  <sect2 id="read-your-writes-consistency">
+  <sect2 id="read-your-writes-consistency" xreflabel="Read-Your-Writes Consistency">
    <title>Read-Your-Writes Consistency</title>
 
    <para>
@@ -1438,7 +1438,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
    </para>
   </sect2>
 
-  <sect2 id="continuous-archiving-in-standby">
+  <sect2 id="continuous-archiving-in-standby" xreflabel="Continuous Archiving in Standby">
    <title>Continuous Archiving in Standby</title>
 
    <indexterm>
@@ -1480,7 +1480,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
   </sect2>
   </sect1>
 
-  <sect1 id="warm-standby-failover">
+  <sect1 id="warm-standby-failover" xreflabel="Failover">
    <title>Failover</title>
 
    <para>
@@ -1567,7 +1567,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
    </para>
   </sect1>
 
- <sect1 id="hot-standby">
+ <sect1 id="hot-standby" xreflabel="Hot Standby">
   <title>Hot Standby</title>
 
   <indexterm zone="high-availability">
@@ -1591,7 +1591,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
     explained below.
    </para>
 
-  <sect2 id="hot-standby-users">
+  <sect2 id="hot-standby-users" xreflabel="User's Overview">
    <title>User's Overview</title>
 
    <para>
@@ -1807,7 +1807,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
    </para>
   </sect2>
 
-  <sect2 id="hot-standby-conflict">
+  <sect2 id="hot-standby-conflict" xreflabel="Handling Query Conflicts">
    <title>Handling Query Conflicts</title>
 
    <para>
@@ -2009,7 +2009,7 @@ postgres=# WAIT FOR LSN '0/306EE20';
    </para>
   </sect2>
 
-  <sect2 id="hot-standby-admin">
+  <sect2 id="hot-standby-admin" xreflabel="Administrator's Overview">
    <title>Administrator's Overview</title>
 
    <para>
@@ -2325,7 +2325,7 @@ HINT:  You can then restart the server after making the necessary configuration
    </para>
   </sect2>
 
-  <sect2 id="hot-standby-parameters">
+  <sect2 id="hot-standby-parameters" xreflabel="Hot Standby Parameter Reference">
    <title>Hot Standby Parameter Reference</title>
 
    <para>
@@ -2348,7 +2348,7 @@ HINT:  You can then restart the server after making the necessary configuration
    </para>
   </sect2>
 
-  <sect2 id="hot-standby-caveats">
+  <sect2 id="hot-standby-caveats" xreflabel="Caveats">
    <title>Caveats</title>
 
    <para>
diff --git a/doc/src/sgml/history.sgml b/doc/src/sgml/history.sgml
index 8bfa1db670d..a051b816b4b 100644
--- a/doc/src/sgml/history.sgml
+++ b/doc/src/sgml/history.sgml
@@ -1,6 +1,6 @@
 <!-- doc/src/sgml/history.sgml -->
 
-<sect1 id="history">
+<sect1 id="history" xreflabel="A Brief History of PostgreSQL">
  <title>A Brief History of <productname>PostgreSQL</productname></title>
 
  <indexterm zone="history">
@@ -23,7 +23,7 @@
   <xref linkend="hell18"/>.
  </para>
 
- <sect2 id="history-berkeley">
+ <sect2 id="history-berkeley" xreflabel="The Berkeley POSTGRES Project">
   <title>The Berkeley <productname>POSTGRES</productname> Project</title>
 
   <indexterm zone="history-berkeley">
@@ -90,7 +90,7 @@
   </para>
  </sect2>
 
- <sect2 id="history-postgres95">
+ <sect2 id="history-postgres95" xreflabel="Postgres95">
   <title><productname>Postgres95</productname></title>
 
   <indexterm zone="history-postgres95">
@@ -188,7 +188,7 @@
   </para>
  </sect2>
 
- <sect2 id="history-postgresql">
+ <sect2 id="history-postgresql" xreflabel="PostgreSQL">
   <title><productname>PostgreSQL</productname></title>
 
   <para>
